{********************************************************************}
{ Run Version 1.00b 15/05/2000                                       }
{                                                                    }
{ Run Component is a start and kill user programm                    }
{                                                                    }
{ Copyright (c) 2000 by PogSoft LAB (http://pog.da.ru)               }
{                                                                    }
{********************************************************************}

{$D-,L-,Y-,I-,S-}
unit Run;

interface

uses Windows, Classes, Controls, StdCtrls, SysUtils;

type

  TRun = class(TComponent)
  private
   FFilePath: String;
   FSi: TStartupInfo;
   FPi: TProcessInformation;

   FExitCode: DWord;

   FWait: Boolean;
   FOnRun, FOnKill: TNotifyEvent;

  procedure SetWait(State: Boolean);
  function ReadExitCode: DWord;

  public
   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
  published
   procedure Run;
   procedure Kill;

   property FilePath: string read FFilePath write FFilePath;
   property Wait: Boolean read FWait write SetWait default False;

   property ExitCode: DWord read ReadExitCode write FExitCode;

   property OnRun: TNotifyEvent read FOnRun write FOnRun;
   property OnKill: TNotifyEvent read FOnKill write FOnKill;
  end;

procedure Register;

implementation

constructor TRun.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FWait:=False;
end; {es}

destructor TRun.Destroy;
begin
 inherited Destroy;
end; {es}

procedure TRun.SetWait(State: Boolean);
begin
 if FWait<>State then FWait:=State;
end; {es}

function TRun.ReadExitCode: DWord;
begin
 GetExitCodeProcess(FPi.hProcess, FExitCode);
 Result:=FExitCode;
end; {es}

procedure TRun.Run;
 Var PB: PChar; R: Longint;
begin
 if Length(FFilePath)>0 then
 Begin
  PB:=StrAlloc(Length(FFilePath)+1);
  StrPLCopy(PB,FFilePath,Length(FFilePath)+1);

  If CreateProcess(Nil,PB,Nil,Nil,False,CREATE_NEW_CONSOLE,Nil,Nil,FSi,FPi) then
  Begin
   if Assigned(FOnRun) then FOnRun(Self);
   If FWait Then R:=WaitForSingleObject(FPi.HProcess,Infinite);
  End;

 StrDispose(PB);
 End; {if}
End; {es}

procedure TRun.Kill;
Begin
 if ExitCode=STILL_ACTIVE then
 Begin
  TerminateProcess(FPi.hProcess,0);
  CloseHandle(FPi.hProcess);
  if Assigned(FOnKill) then FOnKill(Self);
 End;
End; {es}

procedure Register;
begin
 RegisterComponents('Samples', [TRun]);
end; {es}

end.